import java.applet.*;
import java.awt.*;
import java.awt.image.*;

// English version of Spring
public class SpringEn extends Applet implements Runnable {
	int	xw, yw, dx, sleep, move1= -20, move2= -200;
	int sunX=31, sunY=19, radiusRays=20;
	int count=0, grassSize=0, countGrass=90, countFlowers=150;
	String	author="Author: Vladimir N. Korotkov; e-mail: kvn@icp.ac.ru";
	Image buf_image;
	private Graphics buf_g, g2;
	Dimension dimImage;
	Thread timer = null;
		Font font30=new Font("TimesRoman", 1, 30),
			font56=new Font("TimesRoman", 1, 56),
			font22=new Font("TimesRoman", 1, 22),
			font22i=new Font("TimesRoman", 2, 22);
	Font[] font=new Font[7];
	Color	sun1=new Color(255, 255, 0),
			sun2=new Color(255, 255, 255),
			grass1=new Color(0, 204, 0),
			grass2=new Color(0, 255, 0),
			sky=new Color(102, 153, 255),
			skyRays=new Color(153, 204, 255),
			ground=new Color(104, 51, 51);
	Color[] colorFlowers=new Color[5];
	int[] cloudSize={25,35,45,30,30,40,30},
		cloudX={0,8,18,24,8,17,15},
		cloudY={-5,5,10,-5,5,0,5},
		xGround={10, 140};
	char[] vesennie={'s', 'p', 'r', 'i', 'n', 'g', ' '},
			fantazii={'f', 'a', 'n', 't', 'a', 's', 'y'};
	//----------------------------------------------------------------------------------------------------------------------	  
	public void init() {
		colorFlowers[0]=new Color(255,0,0);
		colorFlowers[1]=new Color(255,255,0);
		colorFlowers[2]=new Color(0,0,255);
		colorFlowers[3]=new Color(255,255,255);
		colorFlowers[4]=new Color(255,0,255);

		for (int i=0; i<7; i++)
			font[i]=new Font("TimesRoman", 2, cloudSize[i]);

		xw=size().width;
		yw=size().height;

		dx=Integer.parseInt(getParameter("dx"));
		sleep=Integer.parseInt(getParameter("sleep"));
	
		if (!author.equals(getParameter("Author"))) stop();
			
		Dimension dim = size();
		int nWidth = dim.width;
		int nHeight= dim.height;

		// create a graphics image to paint to
		dimImage = new Dimension(nWidth, nHeight);
		buf_image = createImage(nWidth, nHeight);
		buf_g = buf_image.getGraphics();	 
	} //----------------------------------------------------------------------------------------------------------- end init
	public void paint(Graphics g) {
		if (buf_image != null ) {
			g.drawImage(buf_image, 0, 0, null);
		}	 		 
	} //---------------------------------------------------------------------------------------------------------------------
	public void paintBuffer(Graphics g) {
		
		g.setColor(sky);
		g.fillRect(0,0,xw,yw-22);
		if (count == 0) {
			g.setColor(Color.white);
			g.fillRect(0,yw-22,xw,yw);
		}

		g.setColor(skyRays);
		int r;
		radiusRays = radiusRays >35 ? 22 : radiusRays+1;
		g.fillOval(sunX-radiusRays, sunY-radiusRays, 2*radiusRays, 2*radiusRays);

		// draw SUN
		if (count%2 == 0)	g.setColor(sun1);
		else g.setColor(sun2);

			g.setFont(font30);
			g.drawString("s", 7, 27);
			g.drawString("n", 41, 27);
			

		if (count%2 == 1)	g.setColor(sun1);
		else g.setColor(sun2);
		     	g.setFont(font56);
			g.drawString("u", 15, 32);
		
				
		// draw Ground
		if (count < countGrass && 
			((count==3 || count==7) || (count>17 && count%4 == 3))) {
			int tmp;
			g.setColor(ground);
			g.setFont(font22);
			tmp= count==3 || count==7 ? xGround[count/4] : (int)(-40+xw*Math.random());
			g.drawString("thawed patch", tmp, (int)(yw+2-12*Math.random()));
		}
		// draw GRASS
		if (count > countGrass && count%4 == 0) {
		//	showStatus("The second series.");
			if (count%10 == 0) g.setColor(grass1);
			else g.setColor(grass2);
			g.setFont(font22i);
			g.drawString("grass", (int)(-50+(xw+40)*Math.random()), 
									(int)(yw+2-15*Math.random()));
		}
		// draw FLOWERS
		if (count > countFlowers && count%5 == 0) {
			g.setFont(font22);
				g.setColor(colorFlowers[(count/5)%5]);
				g.drawString("flowers", (int)(-20+(xw-30)*Math.random()), 
										(int)(yw - 11*Math.random()));
		}	  
		// draw CLOUDS
		g.setColor(Color.white);
		move1= move1+dx<xw+160 ? move1+dx : 0;
		move2= move2+dx<xw+160 ? move2+dx : 0;
		for (int tmp=0, tmp2, i=0; i<7; i++) {
			g.setFont(font[i]);
			tmp+=cloudX[i];
			tmp2=(int)(2*Math.sin(5*Math.PI*(xw-move1+tmp)/xw));
//			if (count%7==i) g.setColor(skyRays);
//			else g.setColor(Color.white);
			g.drawChars(vesennie, i, 1, xw-move1+tmp, yw/2-15+cloudY[i]+tmp2);
			g.drawChars(fantazii, i, 1, xw-move2+tmp, yw/2+cloudY[i]+tmp2);
		}
		if (sleep>0) {
			try {timer.sleep(sleep);}
			catch (InterruptedException e){}
		}
		count++;
	}		 
	//----------------------------------------------------------------------------------------------------------------------
	public void run() {
		while (timer != null) {
			repaint(); 	
		}
		timer = null;
	}
	public void update(Graphics g) {
		paintBuffer(buf_g);
		paint(g);
	}
	public void start() {
			timer = new Thread(this);
			timer.start();
	}
	public void stop() {
	  timer = null;
	}		     
} // --------------------------------------------------------------------------------------------------------- end of class
